; --------------------------------- ;
;     Numerical Input Routine       ;
;             By Link               ;
;    On #cemetech and #omnimaga     ;
;        Special Thanks To:         ;
;  benryves, KermM, Cathy, geekboy  ;
; --------------------------------- ;

; Input: hl (location for output)
; Output: de (number)
; Max limit of number is $FFFF
; Destroys hl, de, bc

; Include with: #include "numinput.asm"
; Call with: call numInput

numInput:
	ld (CurRow),hl
	ld hl, $0000
	ld b, h
top:
	push hl
	b_call(_GetKey); Get first key
	pop hl
	; // ------ Check within numeric range ------
	cp 5
	jr z, finish ; // End input if enter pressed
	sub 142 ; Checking upper limit
	jr c, top
	cp 10 ; Checking lower limit
	jr nc, top ; // ------ End numeric check ------
	ld d, h ; // -- Multiply by 10 --
	ld e, l
	add hl, hl
	add hl, hl
	add hl, de
	add hl, hl
	ld c, a ; // Add (append) a to the end of the last digit
	add hl, bc
	add a, $30
	b_call(_PutC) ; // Show the next number / Automatic CurRow and CurCol advancement
	jr top ; // Goto top
finish:
	ret
